Main:
; The purpose of the main program is to test the subroutine lowercaseTest.
; If the subroutine is correct, you will get P1 = 0000 01111.
; {P1 of the Midterm of 2022 Spring}
; Test '0'
	MOV	A,#'{'
	CALL 	lowercaseTest	; Output: C = 0
	MOV	P1.7,C
; Test 'h'
	MOV	A,#'''
	CALL 	lowercaseTest	; Output: C = 0
	MOV	P1.6,C
; Test '8'
	MOV	A,#'6'
	CALL 	lowercaseTest	; Output: C = 0
	MOV	P1.5,C
; Test '&'
	MOV	A,#'Z'
	CALL 	lowercaseTest	; Output: C = 0
	MOV	P1.4,C
; Test '&'
	MOV	A,#'A'
	CALL 	lowercaseTest	; Output: C = 0
	MOV	P1.3,C
; Test '&'
	MOV	A,#'z'
	CALL 	lowercaseTest	; Output: C = 1
	MOV	P1.2,C
; Test '&'
	MOV	A,#'f'
	CALL 	lowercaseTest	; Output: C = 1
	MOV	P1.1,C
; Test '&'
	MOV	A,#'a'
	CALL 	lowercaseTest	; Output: C = 1
	MOV	P1.0,C
	JMP	$



; [Midterm of 2022 Spring1
; Subroutine name: lowercaseTest
; Learning object: To learn the encoding of ASCII code
; Function: 
;      This subroutine tests whether the accumulator contains the ASCII code
;      of a lowercase letter (i.e., a, b, ..., or z). 
; Input: Acc = the code to be tested.
; Output: C = 1, if 'a' =< Acc =< 'z' and
;            C = 0, otherwise.
; Note: 'a' = 61H, 'b' = 62H, ..., 'z' = 7AH                     
lowercaseTest:
	MOV		B,A
	CLR		C
	subb	A,#'a'
	jc		notLowercase
	subb	A,#26
	jnc		notLowercase
isLowercase:
;	MOV		R1,#1   ; test
	SETB	C
	jmp		endLowercaseTest
notLowercase:
;	MOV		R1,#0   ; test
	CLR		C
endLowercaseTest:
	MOV		A,B
	RET
