; Program name: Motor finishes a requested number of rotations 
; Program 3 of 2022 Spring Midterm Exam
; Version 2:
; Feature 1 = The requested rotation number is stored in R7 before the program starts.
; Feature 2 = User can NOT enter new request after the a request has been fulfilled.
;


ORG 0H		
	JMP MAIN	
ORG 13H				; external 1 interrupt vector
	JMP INT1ISR		; jump to the external 1 ISR
MAIN:
	SETB IT1		; set external 0 interrupt as edge-activated
	SETB EX1		; enable external 0 interrupt
	SETB EA			; set the global interrupt enable bit

LEDShow:
	CJNE    R7,#0,startRotate
startSHOW_1:
	DEC R1
	MOV P1,R1
	JMP      LEDShow
startRotate:
	SETB P3.0                     ; | 
	CLR  P3.1                      ; | Rotate motor
startSHOW_2:
	DEC R1
	MOV P1,R1
	JMP	startShow_2		;- Version 2


INT1ISR:
          DJNZ   R7, _rotateMotor
_stopMotor:
	CLR P3.0                      ; |
	CLR P3.1                      ; | stop motor
	JMP	_toReturn  
_rotateMotor:
	SETB P3.0                     ; | 
	CLR  P3.1                      ; | Rotate motor
_toReturn:
	RETI
